#include "response.h"
#include "adc.h"
#include "Ili9320.h"

MARGIN margin[FREQ_COUNT];
uint8_t checkValue(uint16_t *adr, uint16_t value, uint16_t limit);
uint16_t checkMin(uint16_t *adr);
uint16_t checkMax(uint16_t *adr);
uint32_t adc_counter_finish;
uint16_t adc_freq_finish;

/*!
 * \param freq - номер частоты для записи в массив lcd
 */
void setResponse(uint_fast8_t freq){
	uint32_t add=0;
	for (uint8_t i=0;i<LIMIT_COUNT;i++) add+=margin[freq].max.value[i];
	uint16_t value=add/LIMIT_COUNT;
	add=0;
	for (uint8_t i=0;i<LIMIT_COUNT;i++) add+=margin[freq].min.value[i];
	lcd[freq*5+3]=table_bell[(value-add/LIMIT_COUNT)/2];
	flags.adc=1;
}

/*!
 * \param start - начальный адрес массива для обработки
 * \param count - количество значений для обработки
 */
void checkRanges(uint8_t *start, uint16_t count, uint8_t freq){
	for (uint16_t i=0;i<count;i++){
		uint8_t value=*start++;
		// максимальные значения
		if (margin[freq].max.counter<LIMIT_COUNT){
			// заполнение
			margin[freq].max.value[margin[freq].max.counter++]=value;
			if (margin[freq].max.limit>value) margin[freq].max.limit=value;
		}
		else{
			// замещение
			if (value>margin[freq].max.limit){
				if (checkValue(&margin[freq].max.value[0],value,margin[freq].max.limit)==0) margin[freq].max.limit=checkMin(&margin[freq].max.value[0]);
			}
		}
		// минимальные значения
		if (margin[freq].min.counter<LIMIT_COUNT){
			// заполнение
			margin[freq].min.value[margin[freq].min.counter++]=value;
			if (margin[freq].min.limit<value) margin[freq].min.limit=value;
		}
		else{
			// замещение
			if (value<margin[freq].min.limit){
				if (checkValue(&margin[freq].min.value[0],value,margin[freq].min.limit)==0) margin[freq].min.limit=checkMax(&margin[freq].min.value[0]);
			}
		}
	}
}

/*!
 *  поиск в массиве значения limit и его замена на новое значение value.
 *  \param adr - адрес массива
 *  \param limit - значение для поиска
 *  \param value - значение для замены
 *  \return если не ноль, то такие же значения в массиве еще есть
 */
uint8_t checkValue(uint16_t *adr, uint16_t value, uint16_t limit){
	uint8_t r=1;
	for (uint8_t i=0;i<LIMIT_COUNT;i++){
		if (limit==*adr){
			if (r==1) *adr=value;
			r--;
		}
		adr++;
	}
	return r;
}

/*!
 *  поиск в массиве минимального значения
 *  \param adr - адрес массива
 *  \return минимальное значение
 */
uint16_t checkMin(uint16_t *adr){
	uint16_t r=0xFFFF;
	for (uint8_t i=0;i<LIMIT_COUNT;i++){
		if (*adr<r) r=*adr;
		adr++;
	}
	return r;
}

/*!
 *  поиск в массиве максимального значения
 *  \param adr - адрес массива
 *  \return максимальное значение
 */
uint16_t checkMax(uint16_t *adr){
	uint16_t r=0;
	for (uint8_t i=0;i<LIMIT_COUNT;i++){
		if (*adr>r) r=*adr;
		adr++;
	}
	return r;
}

void initDAC(void){
	RCC->APB2ENR |= RCC_APB2Periph_GPIOA;
	RCC->APB1ENR |= (RCC_APB1Periph_DAC | RCC_APB1Periph_TIM6);
	RCC->AHBENR |= RCC_AHBPeriph_DMA2;
	GPIOA->CRL &= ~(GPIO_CRL_MODE5 | GPIO_CRL_CNF5);
	TIM6->EGR=0;
	TIM6->PSC=0;
	TIM6->CR2 = TIM_CR2_MMS_1;
	TIM6->ARR=184;
	DMA2_Channel3->CPAR=(uint32_t)&DAC->DHR12R2;
	DMA2_Channel3->CMAR=(uint32_t)ptable->adr;
	DMA2_Channel3->CNDTR=1;
	DMA2_Channel3->CCR = DMA_CCR3_PL_1 | DMA_CCR3_MSIZE_0 | DMA_CCR3_PSIZE_0 | DMA_CCR3_MINC;
	DMA2_Channel3->CCR |= (/*DMA_CCR3_CIRC | */DMA_CCR3_DIR | DMA_CCR3_TCIE | DMA_CCR3_EN);
	DAC->CR = (DAC_CR_DMAEN1 | DAC_CR_TEN1 | DAC_CR_EN2 |  DAC_CR_BOFF2);
	DAC->DHR12R2=2030;
	TIM6->CR1 |= TIM_CR1_CEN;
//	dac_freq_counter=FREQ_COUNT;
}

// таблица соответствия координаты Y децибелам (200 пиксель = 48 дБ, 0дБ = 2048 48дВ = 6)
const uint16_t table_bell[2048]={
	0x00c7,0x00c7,0x00c7,0x00c7,0x00c7,0x00c7,0x00c7,0x00c7,0x00c7,0x00c5,0x00c1,0x00be,0x00bb,0x00b8,0x00b5,0x00b2,
	0x00b0,0x00ae,0x00ac,0x00aa,0x00a8,0x00a6,0x00a5,0x00a3,0x00a1,0x00a0,0x009f,0x009d,0x009c,0x009b,0x0099,0x0098,
	0x0097,0x0096,0x0095,0x0094,0x0093,0x0092,0x0091,0x0090,0x008f,0x008e,0x008d,0x008c,0x008b,0x008b,0x008a,0x0089,
	0x0088,0x0088,0x0087,0x0086,0x0085,0x0085,0x0084,0x0083,0x0083,0x0082,0x0081,0x0081,0x0080,0x0080,0x007f,0x007e,
	0x007e,0x007d,0x007d,0x007c,0x007c,0x007b,0x007b,0x007a,0x007a,0x0079,0x0079,0x0078,0x0078,0x0077,0x0077,0x0076,
	0x0076,0x0075,0x0075,0x0075,0x0074,0x0074,0x0073,0x0073,0x0072,0x0072,0x0072,0x0071,0x0071,0x0070,0x0070,0x0070,
	0x006f,0x006f,0x006f,0x006e,0x006e,0x006d,0x006d,0x006d,0x006c,0x006c,0x006c,0x006b,0x006b,0x006b,0x006a,0x006a,
	0x006a,0x0069,0x0069,0x0069,0x0068,0x0068,0x0068,0x0067,0x0067,0x0067,0x0067,0x0066,0x0066,0x0066,0x0065,0x0065,
	0x0065,0x0065,0x0064,0x0064,0x0064,0x0063,0x0063,0x0063,0x0063,0x0062,0x0062,0x0062,0x0062,0x0061,0x0061,0x0061,
	0x0061,0x0060,0x0060,0x0060,0x0060,0x005f,0x005f,0x005f,0x005f,0x005e,0x005e,0x005e,0x005e,0x005d,0x005d,0x005d,
	0x005d,0x005d,0x005c,0x005c,0x005c,0x005c,0x005b,0x005b,0x005b,0x005b,0x005b,0x005a,0x005a,0x005a,0x005a,0x005a,
	0x0059,0x0059,0x0059,0x0059,0x0059,0x0058,0x0058,0x0058,0x0058,0x0058,0x0057,0x0057,0x0057,0x0057,0x0057,0x0056,
	0x0056,0x0056,0x0056,0x0056,0x0055,0x0055,0x0055,0x0055,0x0055,0x0055,0x0054,0x0054,0x0054,0x0054,0x0054,0x0053,
	0x0053,0x0053,0x0053,0x0053,0x0053,0x0052,0x0052,0x0052,0x0052,0x0052,0x0052,0x0051,0x0051,0x0051,0x0051,0x0051,
	0x0051,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x004f,0x004f,0x004f,0x004f,0x004f,0x004f,0x004f,0x004e,0x004e,
	0x004e,0x004e,0x004e,0x004e,0x004d,0x004d,0x004d,0x004d,0x004d,0x004d,0x004d,0x004c,0x004c,0x004c,0x004c,0x004c,
	0x004c,0x004c,0x004b,0x004b,0x004b,0x004b,0x004b,0x004b,0x004b,0x004b,0x004a,0x004a,0x004a,0x004a,0x004a,0x004a,
	0x004a,0x0049,0x0049,0x0049,0x0049,0x0049,0x0049,0x0049,0x0049,0x0048,0x0048,0x0048,0x0048,0x0048,0x0048,0x0048,
	0x0047,0x0047,0x0047,0x0047,0x0047,0x0047,0x0047,0x0047,0x0047,0x0046,0x0046,0x0046,0x0046,0x0046,0x0046,0x0046,
	0x0046,0x0045,0x0045,0x0045,0x0045,0x0045,0x0045,0x0045,0x0045,0x0044,0x0044,0x0044,0x0044,0x0044,0x0044,0x0044,
	0x0044,0x0044,0x0043,0x0043,0x0043,0x0043,0x0043,0x0043,0x0043,0x0043,0x0043,0x0042,0x0042,0x0042,0x0042,0x0042,
	0x0042,0x0042,0x0042,0x0042,0x0041,0x0041,0x0041,0x0041,0x0041,0x0041,0x0041,0x0041,0x0041,0x0041,0x0040,0x0040,
	0x0040,0x0040,0x0040,0x0040,0x0040,0x0040,0x0040,0x0040,0x003f,0x003f,0x003f,0x003f,0x003f,0x003f,0x003f,0x003f,
	0x003f,0x003f,0x003e,0x003e,0x003e,0x003e,0x003e,0x003e,0x003e,0x003e,0x003e,0x003e,0x003d,0x003d,0x003d,0x003d,
	0x003d,0x003d,0x003d,0x003d,0x003d,0x003d,0x003d,0x003c,0x003c,0x003c,0x003c,0x003c,0x003c,0x003c,0x003c,0x003c,
	0x003c,0x003c,0x003b,0x003b,0x003b,0x003b,0x003b,0x003b,0x003b,0x003b,0x003b,0x003b,0x003b,0x003a,0x003a,0x003a,
	0x003a,0x003a,0x003a,0x003a,0x003a,0x003a,0x003a,0x003a,0x0039,0x0039,0x0039,0x0039,0x0039,0x0039,0x0039,0x0039,
	0x0039,0x0039,0x0039,0x0039,0x0038,0x0038,0x0038,0x0038,0x0038,0x0038,0x0038,0x0038,0x0038,0x0038,0x0038,0x0038,
	0x0038,0x0037,0x0037,0x0037,0x0037,0x0037,0x0037,0x0037,0x0037,0x0037,0x0037,0x0037,0x0037,0x0036,0x0036,0x0036,
	0x0036,0x0036,0x0036,0x0036,0x0036,0x0036,0x0036,0x0036,0x0036,0x0036,0x0035,0x0035,0x0035,0x0035,0x0035,0x0035,
	0x0035,0x0035,0x0035,0x0035,0x0035,0x0035,0x0035,0x0034,0x0034,0x0034,0x0034,0x0034,0x0034,0x0034,0x0034,0x0034,
	0x0034,0x0034,0x0034,0x0034,0x0034,0x0033,0x0033,0x0033,0x0033,0x0033,0x0033,0x0033,0x0033,0x0033,0x0033,0x0033,
	0x0033,0x0033,0x0033,0x0032,0x0032,0x0032,0x0032,0x0032,0x0032,0x0032,0x0032,0x0032,0x0032,0x0032,0x0032,0x0032,
	0x0032,0x0031,0x0031,0x0031,0x0031,0x0031,0x0031,0x0031,0x0031,0x0031,0x0031,0x0031,0x0031,0x0031,0x0031,0x0031,
	0x0030,0x0030,0x0030,0x0030,0x0030,0x0030,0x0030,0x0030,0x0030,0x0030,0x0030,0x0030,0x0030,0x0030,0x0030,0x002f,
	0x002f,0x002f,0x002f,0x002f,0x002f,0x002f,0x002f,0x002f,0x002f,0x002f,0x002f,0x002f,0x002f,0x002f,0x002f,0x002e,
	0x002e,0x002e,0x002e,0x002e,0x002e,0x002e,0x002e,0x002e,0x002e,0x002e,0x002e,0x002e,0x002e,0x002e,0x002e,0x002d,
	0x002d,0x002d,0x002d,0x002d,0x002d,0x002d,0x002d,0x002d,0x002d,0x002d,0x002d,0x002d,0x002d,0x002d,0x002d,0x002d,
	0x002c,0x002c,0x002c,0x002c,0x002c,0x002c,0x002c,0x002c,0x002c,0x002c,0x002c,0x002c,0x002c,0x002c,0x002c,0x002c,
	0x002c,0x002b,0x002b,0x002b,0x002b,0x002b,0x002b,0x002b,0x002b,0x002b,0x002b,0x002b,0x002b,0x002b,0x002b,0x002b,
	0x002b,0x002b,0x002a,0x002a,0x002a,0x002a,0x002a,0x002a,0x002a,0x002a,0x002a,0x002a,0x002a,0x002a,0x002a,0x002a,
	0x002a,0x002a,0x002a,0x002a,0x0029,0x0029,0x0029,0x0029,0x0029,0x0029,0x0029,0x0029,0x0029,0x0029,0x0029,0x0029,
	0x0029,0x0029,0x0029,0x0029,0x0029,0x0029,0x0029,0x0028,0x0028,0x0028,0x0028,0x0028,0x0028,0x0028,0x0028,0x0028,
	0x0028,0x0028,0x0028,0x0028,0x0028,0x0028,0x0028,0x0028,0x0028,0x0028,0x0027,0x0027,0x0027,0x0027,0x0027,0x0027,
	0x0027,0x0027,0x0027,0x0027,0x0027,0x0027,0x0027,0x0027,0x0027,0x0027,0x0027,0x0027,0x0027,0x0026,0x0026,0x0026,
	0x0026,0x0026,0x0026,0x0026,0x0026,0x0026,0x0026,0x0026,0x0026,0x0026,0x0026,0x0026,0x0026,0x0026,0x0026,0x0026,
	0x0026,0x0025,0x0025,0x0025,0x0025,0x0025,0x0025,0x0025,0x0025,0x0025,0x0025,0x0025,0x0025,0x0025,0x0025,0x0025,
	0x0025,0x0025,0x0025,0x0025,0x0025,0x0025,0x0024,0x0024,0x0024,0x0024,0x0024,0x0024,0x0024,0x0024,0x0024,0x0024,
	0x0024,0x0024,0x0024,0x0024,0x0024,0x0024,0x0024,0x0024,0x0024,0x0024,0x0024,0x0023,0x0023,0x0023,0x0023,0x0023,
	0x0023,0x0023,0x0023,0x0023,0x0023,0x0023,0x0023,0x0023,0x0023,0x0023,0x0023,0x0023,0x0023,0x0023,0x0023,0x0023,
	0x0023,0x0022,0x0022,0x0022,0x0022,0x0022,0x0022,0x0022,0x0022,0x0022,0x0022,0x0022,0x0022,0x0022,0x0022,0x0022,
	0x0022,0x0022,0x0022,0x0022,0x0022,0x0022,0x0022,0x0021,0x0021,0x0021,0x0021,0x0021,0x0021,0x0021,0x0021,0x0021,
	0x0021,0x0021,0x0021,0x0021,0x0021,0x0021,0x0021,0x0021,0x0021,0x0021,0x0021,0x0021,0x0021,0x0021,0x0020,0x0020,
	0x0020,0x0020,0x0020,0x0020,0x0020,0x0020,0x0020,0x0020,0x0020,0x0020,0x0020,0x0020,0x0020,0x0020,0x0020,0x0020,
	0x0020,0x0020,0x0020,0x0020,0x0020,0x0020,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,
	0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001e,0x001e,
	0x001e,0x001e,0x001e,0x001e,0x001e,0x001e,0x001e,0x001e,0x001e,0x001e,0x001e,0x001e,0x001e,0x001e,0x001e,0x001e,
	0x001e,0x001e,0x001e,0x001e,0x001e,0x001e,0x001e,0x001e,0x001d,0x001d,0x001d,0x001d,0x001d,0x001d,0x001d,0x001d,
	0x001d,0x001d,0x001d,0x001d,0x001d,0x001d,0x001d,0x001d,0x001d,0x001d,0x001d,0x001d,0x001d,0x001d,0x001d,0x001d,
	0x001d,0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,
	0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,0x001c,0x001b,0x001b,0x001b,0x001b,
	0x001b,0x001b,0x001b,0x001b,0x001b,0x001b,0x001b,0x001b,0x001b,0x001b,0x001b,0x001b,0x001b,0x001b,0x001b,0x001b,
	0x001b,0x001b,0x001b,0x001b,0x001b,0x001b,0x001b,0x001a,0x001a,0x001a,0x001a,0x001a,0x001a,0x001a,0x001a,0x001a,
	0x001a,0x001a,0x001a,0x001a,0x001a,0x001a,0x001a,0x001a,0x001a,0x001a,0x001a,0x001a,0x001a,0x001a,0x001a,0x001a,
	0x001a,0x001a,0x001a,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,
	0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,0x0019,
	0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,
	0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0018,0x0017,0x0017,0x0017,
	0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,
	0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0017,0x0016,0x0016,0x0016,0x0016,
	0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,
	0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,0x0016,0x0015,0x0015,0x0015,0x0015,0x0015,
	0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,
	0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,0x0015,0x0014,0x0014,0x0014,0x0014,0x0014,
	0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,
	0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0014,0x0013,0x0013,0x0013,0x0013,
	0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,
	0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0013,0x0012,0x0012,
	0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,
	0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,0x0012,
	0x0012,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,
	0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,0x0011,
	0x0011,0x0011,0x0011,0x0011,0x0011,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,
	0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,
	0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x0010,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,
	0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,
	0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,0x000f,
	0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,
	0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,
	0x000e,0x000e,0x000e,0x000e,0x000e,0x000e,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,
	0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,
	0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000d,0x000c,
	0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,
	0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,
	0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000c,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,
	0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,
	0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,0x000b,
	0x000b,0x000b,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,
	0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,
	0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x000a,0x0009,0x0009,
	0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,
	0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,
	0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0009,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,
	0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,
	0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,
	0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0008,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,
	0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,
	0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,
	0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0007,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,
	0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,
	0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,
	0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0006,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,
	0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,
	0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,
	0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0005,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,
	0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,
	0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,
	0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0004,0x0003,0x0003,
	0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,
	0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,
	0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,0x0003,
	0x0003,0x0003,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,
	0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,
	0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,
	0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0002,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,
	0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,0x0001,
	};

// таблица соответствия координаты Y децибелам (200 пиксель = 48 дБ, 0дБ = 2048 48дВ = 6)
/*const uint16_t table_bell[200]={
	0x0800,0x07c8,0x0791,0x075d,0x0729,0x06f7,0x06c7,0x0697,0x0669,0x063d,0x0611,0x05e7,0x05be,0x0595,0x056f,0x0549,
	0x0524,0x0500,0x04dd,0x04bb,0x049a,0x047a,0x045b,0x043c,0x041f,0x0402,0x03e6,0x03cb,0x03b0,0x0397,0x037d,0x0365,
	0x034d,0x0336,0x0320,0x030a,0x02f5,0x02e0,0x02cc,0x02b9,0x02a6,0x0293,0x0281,0x0270,0x025f,0x024e,0x023e,0x022e,
	0x021f,0x0210,0x0202,0x01f4,0x01e6,0x01d9,0x01cc,0x01c0,0x01b3,0x01a7,0x019c,0x0191,0x0186,0x017b,0x0171,0x0167,
	0x015d,0x0153,0x014a,0x0141,0x0138,0x0130,0x0128,0x011f,0x0118,0x0110,0x0109,0x0101,0x00fa,0x00f3,0x00ed,0x00e6,
	0x00e0,0x00da,0x00d4,0x00ce,0x00c9,0x00c3,0x00be,0x00b9,0x00b4,0x00af,0x00aa,0x00a5,0x00a1,0x009c,0x0098,0x0094,
	0x0090,0x008c,0x0088,0x0084,0x0081,0x007d,0x007a,0x0076,0x0073,0x0070,0x006d,0x006a,0x0067,0x0064,0x0062,0x005f,
	0x005c,0x005a,0x0057,0x0055,0x0053,0x0050,0x004e,0x004c,0x004a,0x0048,0x0046,0x0044,0x0042,0x0040,0x003e,0x003d,
	0x003b,0x0039,0x0038,0x0036,0x0035,0x0033,0x0032,0x0031,0x002f,0x002e,0x002d,0x002b,0x002a,0x0029,0x0028,0x0027,
	0x0026,0x0025,0x0024,0x0023,0x0022,0x0021,0x0020,0x001f,0x001e,0x001d,0x001d,0x001c,0x001b,0x001a,0x001a,0x0019,
	0x0018,0x0017,0x0017,0x0016,0x0016,0x0015,0x0014,0x0014,0x0013,0x0013,0x0012,0x0012,0x0011,0x0011,0x0010,0x0010,
	0x000f,0x000f,0x000e,0x000e,0x000e,0x000d,0x000d,0x000d,0x000c,0x000c,0x000c,0x000b,0x000b,0x000b,0x000a,0x000a,
	0x000a,0x0009,0x0009,0x0009,0x0009,0x0008,0x0008,0x0008,
	};*/
